<template>
  <div class="chat-pinmsg" v-if="visible" @click="scrollToView">
    <label>消息：</label>
    <div class="msg-content">{{msg | decryptoMsg}}</div>
    <i class="msg-close" @click.stop="handleClose"></i>
  </div>
</template>

<script>
import { MessageBox } from 'element-ui'
import { mapState, mapActions } from 'vuex'
import { decryptoMsg } from '@/util/util.js'
export default {
  name: 'pinMsg',
  props: {
    visible: {
      type: Boolean,
      default: false
    },
    msg: {
      type: String,
      default: ''
    },
    hash: {
      type: String
    }
  },
  data () {
    return {
    }
  },
  computed: {
    ...mapState([
      'userId'
    ]),
    ...mapState({
      adminList: state => state.group.adminList
    }),
    isAdmin () {
      return this.adminList && this.adminList.some(id => id == this.userId)
    }
  },
  methods: {
    ...mapActions(['doUnpinMsg']),
    handleClose (event) {
      if (this.isAdmin) {
        MessageBox.confirm('确定要关闭置顶消息吗？').then(() => {
          this.doUnpinMsg({ hash: this.hash })
        }).catch((e) => {
          console.log(e)
        })
      } else {
        this.$emit('pinMsgClose')
      }

      //      event.stopPropagation()
      //      return false
    },
    scrollToView (event) {
      this.$emit('scrollToView')
    }
  },
  mounted () {

  },
  filters: {
    decryptoMsg: decryptoMsg
  }
}
</script>

<style lang="scss" scoped>
.chat-pinmsg{
  display: flex;
  height: 30px;
  background-color:#fafafa;
  justify-content: center;
  align-items: center;
  font-size: 12px;
  padding: 0 5px;
}
label{
  padding-left: 7px;
  font-weight: bold;
}
.msg-content{
    flex:1;
    width: 0;
    height: 30px;
    line-height: 30px;
    text-align: center;
    overflow: hidden;
    white-space: nowrap;
    text-overflow: ellipsis;
}
.msg-close{
  display: block;
  width: 20px;
  height: 20px;
  background: url("../../assets/icon_msg_close.png") no-repeat;
  background-size: 100% 100%;
}
.msg-content{
  cursor: pointer;
}
</style>
